package com.eneraptor.hci

class HciLogicCommService {

    static transactional = true

    Map getReplyToRequest(String requestContent,String ipAddress,int portNum) {
		
		Map reply = new HashMap()
		
		Socket logicSocket = null;
		PrintWriter toLogic = null;
		BufferedReader fromLogic = null;

		try {
			logicSocket = new Socket(ipAddress, portNum);
			toLogic = new PrintWriter(logicSocket.getOutputStream(), true);
			fromLogic = new BufferedReader(new InputStreamReader(
										logicSocket.getInputStream()));
		} catch (UnknownHostException e) {
			reply['status'] = "error"
			reply['content'] = "Unknown host: "
			reply['content'] += e.getMessage()
			fromLogic?.close()
			toLogic?.close()
			logicSocket?.close()
			return reply
		} catch (IOException e) {
			reply['status'] = "error"
			reply['content'] += e.getMessage()
			fromLogic?.close()
			toLogic?.close()
			logicSocket?.close()
			return reply
		}
		
		reply['status'] = "ok"
		reply['content'] = ""
		toLogic.println(requestContent)
		List allLines = new ArrayList()
		allLines = fromLogic.readLines()
		allLines.each {
			reply['content'] += it.toString() + "\n"
		}
		
		fromLogic.close()
		toLogic.close()
		logicSocket.close()
		
		return reply

    }
	
}
